/* =========================================================================

NAME: UltraBorder

AUTHOR: Oleg Butrin (obutrin@indesign.rudtp.ru)

HOMEPAGE: http://indesign.rudtp.ru
DATE  : 20.02.2004 15:39



COMMENT:
Script replace searched words to inline objects

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
//@include 'Words2Inlines.ini'

with (app) {
//   
	if (documents.length < 1) {
		alert (langNoDocOpen);
		exit();
	}
//,    
	if ((selection.length == 1)&&((selection[0].constructor.name == "TextFrame")||(selection[0].constructor.name == "Text")||(selection[0].constructor.name == "InsertionPoint"))) {
		mySelections = true;
	} else {
		mySelections = false;
	}
//        
	var myRecordFilesFolder = new Folder (activeScript.path);
	var myRecordFilesNames = getShortNames(myRecordFilesFolder, myRecordFilesFolder.getFiles("*.w2i3"));
//  
	var myOptionDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion});
//  
	with (myOptionDialog.dialogColumns.add()) {
		with (borderPanels.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:langSearchOptions});
			var mySearchOption = radiobuttonGroups.add();
			with(mySearchOption) {
				radiobuttonControls.add({staticLabel:langSearchInDoc, checkedState:!mySelections});
				radiobuttonControls.add({staticLabel:langSearchInObj, checkedState:mySelections});
			}
		}
// (!)
		dialogRows.add().staticTexts.add({staticLabel:"\u00A9 Oleg Butrin"});
		dialogRows.add().staticTexts.add({staticLabel:"http://indesign.rudtp.ru"});			
	}
	with (myOptionDialog.dialogColumns.add().borderPanels.add().dialogColumns.add()) {
// 
		dialogRows.add().staticTexts.add({staticLabel:langRecordFile});
		var myRecordFile = dropdowns.add({stringList:myRecordFilesNames, minWidth:130, selectedIndex:0});
// 
		var myEditOptionsGroup = dialogRows.add().enablingGroups.add({staticLabel:langEditOptions});
		with (myEditOptionsGroup) {
			var myEditOptions = radiobuttonGroups.add();
			with (myEditOptions) {
				radiobuttonControls.add({staticLabel:langEditCurrent, checkedState:true});
				radiobuttonControls.add({staticLabel:langEditNew});
			}
		}
	}
// 
	var myResult = myOptionDialog.show();
	if (!myResult) {
		exit();
	}
// 	
	if (myEditOptionsGroup.checkedState) {
//   ,  
		if (libraries.length < 1 ) {
			alert (langNoOneLibOpen);
			exit();
		}
//   
		var myLibNames = new Array();
		for (myCounter = 0; myCounter < libraries.length; myCounter++) {
			myLibNames[myCounter] = libraries[myCounter].name;
		}
//    
		if (myEditOptions.selectedButton == 1) {
			myEdit = false;
//      
			var myLibSelectDialog = dialogs.add({name:langSelectLibFile, canCancel:false});
			with (myLibSelectDialog.dialogColumns.add().dialogRows.add()) {
				with (dialogColumns.add()){
					staticTexts.add({staticLabel:langLibrary})
					staticTexts.add({staticLabel:langFile})
				}
				with (dialogColumns.add()){
					var selectLibrary = dropdowns.add({stringList:myLibNames, selectedIndex:0});
					with (dialogRows.add()) {
						var selectFile = textEditboxes.add();
						staticTexts.add({staticLabel:".w2i3"});
					}
				}
			}
//  
			var myResult = myLibSelectDialog.show();
			if (!myResult) {
				exit();
			}
//   
			var myEditLibrary = libraries[selectLibrary.selectedIndex];
			var myFile = new File (activeScript.path + "/" + selectFile.editContents + ".w2i3");
//  
		} else {
			myEdit = true;
//  
			eval ("//@include \'" + myRecordFilesNames[myRecordFile.selectedIndex] + "\';");
//  ,   
			try {
				var myEditLibrary = libraries.item(myLibName);
			}
			catch (error) {
				var myEditLibrary = null;
			}
//  ,  
			if (myEditLibrary == null) {
				alert(myLibName + " " + langNoLibOpen);
				exit();
			}
// 
			var myFile = new File (activeScript.path + "/" + myRecordFilesNames[myRecordFile.selectedIndex]);
		}
//   		
		var myEditDialog = dialogs.add({name:langEditValues})
//      		
		var myAssetsArray = new Array ();
		var myRecordArray = new Array ();
// ,  ,     
		var myAssetRecord = new Array();
//  		
		for (myCounter = 0; myCounter < myEditLibrary.assets.length; myCounter++) {
//    10,     
			if ((myCounter % 10) == 0) {
				var myAssetColumn = myEditDialog.dialogColumns.add();
				var myRecordColumn = myEditDialog.dialogColumns.add();
			}
//        ,  
			if (myEdit && (isAssetStore(myEditLibrary.assets[myCounter].name, myRecords))) {
				myAssetRecord[myCounter] = myRecords[myEditLibrary.assets[myCounter].name];
			}
//      
			with (myAssetColumn.dialogRows.add()) {
				myAssetsArray[myCounter] = checkboxControls.add({staticLabel:myEditLibrary.assets[myCounter].name, checkedState:(myAssetRecord[myCounter] ? myAssetRecord[myCounter][0] : false)});
			}
//   
			with (myRecordColumn.dialogRows.add()) {
				myRecordArray[myCounter] = textEditboxes.add({editContents:(myAssetRecord[myCounter] ? myAssetRecord[myCounter][1] : "")})
			}
		}
//  
		var myResult = myEditDialog.show();
		if (!myResult) {
			alert (langNoSave);
			exit();
		}
//   		
		var myFile = new File (myFile);
		with (myFile) {
			open ("w");
//  
			writeln ("var myLibName = \'" + myEditLibrary.name + "\';");
//   (    )
			writeln ("var myLibLength = " + myEditLibrary.assets.length + ";");
			writeln ("var myRecords = new Array ();");
//  
			for (myCounter = 0; myCounter < myAssetsArray.length; myCounter++) {
				writeln ("myRecords[\'" + myAssetsArray[myCounter].staticLabel + "\'] = new Array (" + myAssetsArray[myCounter].checkedState + ", \'" + myRecordArray[myCounter].editContents + "\');");
			}
			close();
		}
		exit();
	}
// 	
//  
	eval ("//@include \'" + myRecordFilesNames[myRecordFile.selectedIndex] + "\';");
//  
	try {
		var myCurrentLib = libraries.item(myLibName);
	}
	catch (error) {
		var myCurrentLib = null;
	}
//  ,  
	if (myCurrentLib == null) {
		alert(myLibName + " " + langNoLibOpen);
		exit();
	}
//    
	for (myCounter = 0; myCounter < myCurrentLib.assets.length; myCounter++) {
//       
		if ((isAssetStore(myCurrentLib.assets[myCounter].name, myRecords)) && (myRecords[myCurrentLib.assets[myCounter].name][0])) {
// 
			switch (mySearchOption.selectedButton) {
				case 0:
					var mySearchObjects = activeDocument.search(myRecords[myCurrentLib.assets[myCounter].name][1], true, true, myRecords[myCurrentLib.assets[myCounter].name][1]);
					break;
				case 1:
					if (selection.length == 0) {
						alert (langNoSelection);
						exit();
					} else {
						if ((selection[0].constructor.name == "TextFrame")||(selection[0].constructor.name == "Text")||(selection[0].constructor.name == "InsertionPoint")) {
							var mySearchObjects = selection[0].parentStory.search(myRecords[myCurrentLib.assets[myCounter].name][1], true, true, myRecords[myCurrentLib.assets[myCounter].name][1]);
						} else {
							break;
						}
					}
			}
//   ,    
			mySearchObjects.reverse();
//   
			for (myObj = 0; myObj < mySearchObjects.length; myObj++) {
//
				mySearchObjects[myObj].select();
//    
				myCurrentLib.assets[myCounter].placeAsset(activeDocument);
			}
		}
	}
}
//
//     ( )
function getShortNames (myFolder, myFiles) {
	var myShortName = new Array ();
	for (myCounter = 0; myCounter < myFiles.length; myCounter++) {
		myShortName[myCounter] = myFiles[myCounter].name;
	}
	return myShortName;
}
//      
function isAssetStore (myName, myArray) {
	myResult = false;
	for (myProp in myArray) {
		if (myName == myProp) {
			myResult = true;
			break;
		}
	}
	return myResult;
}